﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.51
@EndOfDesignText@
#DesignerProperty: Key: Duration, DisplayName: Animation Duration, FieldType: Int, DefaultValue: 800, Description: The Duration of the Ripple Animation. Default is 800.
#DesignerProperty: Key: FadeDuration, DisplayName: Fade Duration, FieldType: Int, DefaultValue: 3000, Description: The Duration of the Ripple Animation. Default is 3000.
#DesignerProperty: Key: RippleColor, DisplayName: Ripple Color, FieldType: Color, DefaultValue: 0xFF39569A, Description: The Color of the Ripple Effect.

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Private running As Boolean = True
	
	'p = properties
	Private p_duration As Int
	Private p_fadeduration As Int
	Private p_color As Int
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base

	ini_props(Props)

	CreateHaloEffect(mBase)

End Sub

Private Sub ini_props(Props As Map)
	
	p_duration = Props.Get("Duration")
	p_fadeduration = Props.Get("FadeDuration")
	p_color = xui.PaintOrColorToColor(Props.Get("RippleColor"))
	
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
	mBase.SetLayoutAnimated(0,0,0,Width,he
  
End Sub


Sub CreateHaloEffect (Parent As B4XView)
	Dim cvs As B4XCanvas
	Dim p As B4XView = xui.CreatePanel("")
	Dim radius As Int = mBase.Width/2
	p.SetLayoutAnimated(0, 0, 0, radius * 2, radius * 2)
	cvs.Initialize(p)
	cvs.DrawCircle(cvs.TargetRect.CenterX, cvs.TargetRect.CenterY, cvs.TargetRect.Width / 2, p_color, True, 0)
	Dim bmp As B4XBitmap = cvs.CreateBitmap
	Do While running = True
		CreateHaloEffectHelper(Parent,bmp, mBase.Width/2, mBase.Height/2, radius)
		Sleep(p_duration)
	Loop
End Sub

Sub CreateHaloEffectHelper (Parent As B4XView,bmp As B4XBitmap, x As Int, y As Int, radius As Int)
	Dim iv As ImageView
	iv.Initialize("")
	Dim p As B4XView = iv
	p.SetBitmap(bmp)
	Parent.AddView(p, x, y, 0, 0)
	p.SetLayoutAnimated(p_fadeduration, x - radius, y - radius, 2 * radius, 2 * radius)
	p.SetVisibleAnimated(p_fadeduration, False)
	Sleep(p_fadeduration)
	p.RemoveViewFromParent
End Sub